package com.casic.dcms.vm;

import android.content.Context;

import androidx.lifecycle.MutableLiveData;

import com.casic.dcms.model.ActionResultBean;
import com.casic.dcms.model.WellAlarmListBean;
import com.casic.dcms.utils.StringHelper;
import com.casic.dcms.utils.retrofit.RetrofitServiceManager;
import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.pengxh.androidx.lite.base.BaseViewModel;
import com.pengxh.androidx.lite.kit.StringKit;
import com.pengxh.androidx.lite.utils.LoadState;
import com.pengxh.androidx.lite.utils.ObserverSubscriber;

import java.io.IOException;

import okhttp3.ResponseBody;
import rx.Observable;

public class AlarmViewModel extends BaseViewModel {
    private final Gson gson = new Gson();
    public MutableLiveData<WellAlarmListBean> wellAlarmListResult = new MutableLiveData<>();
    public MutableLiveData<ActionResultBean> cancelActionModel = new MutableLiveData<>();

    public void getAlarmList(Context context, int offset) {
        loadState.setValue(LoadState.Loading);
        Observable<ResponseBody> alarmListObservable = RetrofitServiceManager.getAlarmList(offset);
        ObserverSubscriber.addSubscribe(alarmListObservable, new ObserverSubscriber.OnObserverCallback() {
            @Override
            public void onCompleted() {
                loadState.setValue(LoadState.Success);
            }

            @Override
            public void onError(Throwable e) {
                loadState.setValue(LoadState.Fail);
            }

            @Override
            public void onNext(ResponseBody responseBody) {
                try {
                    String response = responseBody.string();
                    int responseCode = StringHelper.getResponseCode(response);
                    if (responseCode == 200) {
                        WellAlarmListBean alarmDataBean = gson.fromJson(response, new TypeToken<WellAlarmListBean>() {
                        }.getType());
                        wellAlarmListResult.setValue(alarmDataBean);
                        loadState.setValue(LoadState.Success);
                    } else {
                        loadState.setValue(LoadState.Fail);
                        StringKit.show(context, StringHelper.getResponseMessage(response));
                    }
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        });
    }

    public void cancelSingleAlarm(Context context, String id, String jobStatus, String handleMessage) {
        Observable<ResponseBody> commonActionObservable = RetrofitServiceManager.getCancelAlarmResult(id, jobStatus, handleMessage);
        ObserverSubscriber.addSubscribe(commonActionObservable, new ObserverSubscriber.OnObserverCallback() {
            @Override
            public void onCompleted() {

            }

            @Override
            public void onError(Throwable e) {

            }

            @Override
            public void onNext(ResponseBody responseBody) {
                try {
                    String response = responseBody.string();
                    int responseCode = StringHelper.getResponseCode(response);
                    if (responseCode == 200) {
                        ActionResultBean resultBean = gson.fromJson(response, new TypeToken<ActionResultBean>() {
                        }.getType());
                        cancelActionModel.setValue(resultBean);
                    } else {
                        StringKit.show(context, StringHelper.getResponseMessage(response));
                    }
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        });
    }

    public void cancelBatchAlarm(Context context, String jobStatus, String handleMessage) {
        Observable<ResponseBody> commonActionObservable = RetrofitServiceManager.getCancelAlarmResult(jobStatus, handleMessage);
        ObserverSubscriber.addSubscribe(commonActionObservable, new ObserverSubscriber.OnObserverCallback() {
            @Override
            public void onCompleted() {

            }

            @Override
            public void onError(Throwable e) {

            }

            @Override
            public void onNext(ResponseBody responseBody) {
                try {
                    String response = responseBody.string();
                    int responseCode = StringHelper.getResponseCode(response);
                    if (responseCode == 200) {
                        ActionResultBean resultBean = gson.fromJson(response, new TypeToken<ActionResultBean>() {
                        }.getType());
                        cancelActionModel.setValue(resultBean);
                    } else {
                        StringKit.show(context, StringHelper.getResponseMessage(response));
                    }
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        });
    }
}
